#include <cmath>
#include <iostream>
#include "rationnel.hpp"

using namespace std;

void plot_r::plot(rationnel x){
  cout<< ">>> Sortie par classe amis."<<" n: "<<x.n<<" d: "<<x.d<<endl;
}

bool rationnel::positif(){
  bool res = false;
  if( n*d > 0) { res = true; }
  return res;
}
bool rationnel::negatif(){
  bool res = false;
  if( n*d < 0) { res = true; }
  return res;
}

rationnel rationnel::modify_n(int nn){
  n = nn;
  return *this;
}
rationnel rationnel::modify_d(int nd){
  d = nd;
  return *this;
}

int rationnel::num(){
  return n;
}

int rationnel::dem(){
  return d;
}

rationnel:: operator int (){
  int res;
  res = n/d;
  return res;
}


rationnel rationnel:: operator + (rationnel x){
  rationnel res;
  res.d = d*x.d;
  res.n = x.d*n + d*x.n;
  return res;
}

rationnel & rationnel:: operator = (const rationnel & x){
  if(&x != this){
    d = x.d;
    n = x.n;
  }
  return *this; 
}

rationnel rationnel:: operator - (rationnel x){
  rationnel res;
  res.d = d*x.d;
  res.n = x.d*n - d*x.n;
  return res;
}

rationnel rationnel:: operator * (rationnel x){
  rationnel res;
  res.d = d*x.d;
  res.n = n*x.n;
  return res;
}

rationnel rationnel:: operator / (rationnel x){
  rationnel res;
  res.d = d*x.n;
  res.n = n*x.d;
  return res;
}

bool rationnel:: operator < (rationnel x){
  bool res = false;
  if(n*x.d < d*x.n) { res = true;}
  return res;
}

bool rationnel:: operator > (rationnel x){
  bool res = false;
  if(n*x.d > d*x.n) { res = true;}
  return res;
}

bool rationnel:: operator == (rationnel x){
  bool res = false;
  if((n/x.n) == (d/x.d)) { res = true;}
  return res;
}

ostream & operator<<(ostream & out,const rationnel & x){
  out<<x.n<<"/"<<x.d;
  return out;
}

rationnel operator *(int a, const rationnel & x){
   rationnel res;
   res.n = a*x.n;
   res.d = a*x.d;
   return res;
}


void plot_objet(rationnel x){
  cout<< ">>> objet rationnel "<<endl;
}

void plot_objet2(rationnel & x){
  cout<< ">>> objet rationnel "<<endl;
}

void plot_values(rationnel x){
  cout<< ">>> n: "<<x.n<<" d: "<<x.d<<endl;
}

int rationnel::testu_1(){
  // test opération
  rationnel x(1,2);
  rationnel y(1,3);
  rationnel z(-2,5);
  
  *this = x+y; // res =5/6
  *this = *this * z; // res = -10/30
  *this = *this /x - y;  // res = -20/30- 1/3 = -90/90
  if(this->num() == -90 && this->dem() == 90){ return 0; }
  else { return 1; }
}


int rationnel::testu_2(){
  // test signe + modification
  rationnel x(1,2);
  bool signe1 = false, signe2 = false, signe3 = false;
  *this = x;
  signe1 = this->positif();
  this->modify_n(-1.0);
  signe2 = this->negatif();
  this->modify_d(-2.0);
  signe3 = this->positif();

  if(signe1 && signe2 && signe3){ return 0; }
  else { return 1; }
}

int rationnel::testu_3(){
  // tes tcomparaison 
  rationnel x1(1,2);
  rationnel x2(1,3);
  rationnel x3(3,6);
  bool a,b,c;
  *this = x1;
  a = x2 < *this ; b = *this > x2; c = (*this == x3);

  if(a && b & c){ return 0; }
  else { return 1; }
}

int rationnel:: all_testsu(){
  int c=0,t=0;
  rationnel x;
  c=x.testu_1(); t = t +c;
  c=x.testu_2(); t = t +c;
  c=x.testu_3(); t = t +c;
  cout<<"Tests unitaires réussis, classe rationnel: "<<3-t<<"/3"<<endl;
  return 0;
}

